SuperStrict
Framework BaH.Graphviz
Import BaH.GraphvizMax2D

Import BRL.StandardIO
Import BRL.TextStream

Import BRL.max2d
Import BRL.glmax2d

Import bah.random

Import artemis.avltree

SeedRnd(MilliSecs())

Type TObj
	Field _value:Int
	
	Method Create:TObj(value:Int)
		Self._value = value
		Return Self
	EndMethod
	
	Method toString:String()
		Return String(Self._value)
	EndMethod
	
	Method compare:Int(obj:Object)
		Local obj_:TObj = TObj(obj)
		
		If Not obj_ Then Return 0
		
		If Self._value > obj_._value Then Return -1
		If Self._value < obj_._value Then Return  1
		Return 0
	EndMethod
EndType

Local tree:TAVLTree = New TAVLTree
Local change:Int

'DebugStop

Const W:Int = 1440
Const H:Int = 600

Local renderer:TGVGraphviz = TGVGraphviz.Create(W, H)

tree.insert(New TObj.Create(Rand(0, 10)), change)
Local graph:String = "digraph G {~nsize = ~q8,8~q;~n" + tree.dump() + "~n}"
renderer.loadGraphText(graph)

Graphics W, H, 0

glEnable GL_LINE_SMOOTH
SetBlend alphablend

renderer.layout("dot")
renderer.fit(W, H)


Local mx:Int
Local my:Int
Local mz:Int
Local oldZ:Int
Local buttons:Int[] = New Int[3]

While Not KeyDown(KEY_ESCAPE)
	
	
	If KeyDown(KEY_ENTER) Then
'		DebugStop
		tree.insert(New TObj.Create(Rand(0, 10)), change)
		Local graph:String = "digraph G {~nsize = ~q8,8~q;~n" + tree.dump() + "~n}"
		renderer.loadGraphText(graph)
		renderer.layout("dot")
'		renderer.fit(W, H)
	EndIf

	Cls
	
	SetColor(255, 255, 255)
	
	mx = MouseX()
	my = MouseY()
	mz = MouseZ()
	
	renderer.mouseMove(mx, my)
	
	For Local i:Int = 1 To 3
		If MouseDown(i)
			If Not buttons[i - 1] Then
				renderer.MouseDown(mx, my, i)
				buttons[i - 1] = 1
			End If
		Else
			If buttons[i - 1] Then
				buttons[i - 1] = 0
				renderer.mouseUp(mx, my, i)
			End If
		End If
	Next
	
	If mz <> oldZ Then
		If mz < oldZ Then
			renderer.mouseScroll(mx, my, -1) ' scroll up - zoom in
		Else
			renderer.mouseScroll(mx, my, 1) ' scroll down - zoom out
		End If
		oldZ = mz
	End If
	
	' refresh/redraw the graph
	renderer.refresh()

	Flip
Wend

End
