SuperStrict
Rem
bbdoc: Artemis.Queue
about:
A queue implementation for the Object type.
EndRem
Module Artemis.Queue

Public

Rem
bbdoc: A queue implementation
EndRem
Type TQueue
	Field _head:TQueueElement = Null
	Field _tail:TQueueElement = Null
	Field _size:Int           = 0
	
	Method Create:TQueue()
		Return Self
	EndMethod
	
	Rem
	bbdoc: Check whether queue is empty
	returns: 1 if queue is empty - otherwise 0.
	EndRem
	Method isEmpty:Int()
		Return Null = Self._head
	EndMethod
	
	Rem
	bbdoc: Return the size of the queue
	returns: The queue size.
	EndRem
	Method getSize:Int()
		Return Self._size
	EndMethod
	
	Rem
	bbdoc: Add an object to the queue
	EndRem
	Method enqueue(value:Object)
		Local tmp:TQueueElement = New TQueueElement.Create(value)
		If Null = Self._tail Then
			Self._head = tmp
		Else
			Self._tail.setNext(tmp)
		EndIf
		Self._tail = tmp
		Self._size :+ 1
	EndMethod
	
	Rem
	bbdoc: Remove an object from the queue
	returns: The first object.
	EndRem
	Method dequeue:Object()
		If Null = Self._head Then Return Null
		Local tmp:Object = Self._head
		Self._head = Self._head.getNext()
		Self._size :- 1
		Return tmp
	EndMethod
	
	Rem
	bbdoc: Give the first object
	returns: The first object.
	EndRem
	Method getFirst:Object()
		If Null = Self._head Then Return Null
		Return Self._head.getValue()
	EndMethod
EndType

Private

Type TQueueElement
	Field _value:Object
	Field _next:TQueueElement
	
	Method Create:TQueueElement(value:Object)
		Self._value = value
		Self._next = Null
		Return Self
	EndMethod
	
	Method setNext(next_:TQueueElement)
		Self._next = next_
	EndMethod
	
	Method getNext:TQueueElement()
		Return Self._next
	EndMethod
	
	Method getValue:Object()
		Return Self._value
	EndMethod
EndType