SuperStrict
Rem
bbdoc: Artemis.Stack
about:
A linked list stack implementation for the Object type.
EndRem
Module Artemis.Stack

Public

Rem
bbdoc: A Stack implementation
EndRem
Type TStack
	Field _top:TStackElement = Null
	
	Method Create:TStack()
		Return Self
	EndMethod
	
	Rem
	bbdoc: Check whether stack is empty.
	returns: 1 if stack is empty - otherwise 0.
	EndRem
	Method isEmpty:Int()
		Return Null = Self._top
	EndMethod
	
	Rem
	bbdoc: Push an object to the stack
	EndRem
	Method push(value:Object)
		Local tmp:TStackElement = New TStackElement.Create(value)
		tmp.setNext(Self._top)
		Self._top = tmp
	EndMethod
	
	Rem
	bbdoc: Pop an object from the stack
	returns: The current top object.
	EndRem
	Method pop:Object()
		If Null = Self._top Then Return Null
		Local tmp:Object = Self._top._value
		Self._top = Self._top.getNext()
		Return tmp
	EndMethod
	
	Rem
	bbdoc: Give the current top object
	returns: The current top object.
	EndRem
	Method getTop:Object()
		If Null = Self._top Then Return Null
		Return Self._top.getValue()
	EndMethod
EndType

Private

Type TStackElement
	Field _value:Object
	Field _next:TStackElement
	
	Method Create:TStackElement(value:Object)
		Self._value = value
		Self._next = Null
		Return Self
	EndMethod
	
	Method setNext(next_:TStackElement)
		Self._next = next_
	EndMethod
	
	Method getNext:TStackElement()
		Return Self._next
	EndMethod
	
	Method getValue:Object()
		Return Self._value
	EndMethod
EndType
