SuperStrict
Rem
bbdoc: Artemis.StopWatch
about:
Watch the time something takes.
EndRem
Module Artemis.StopWatch

Rem
bbdoc: A stopwatch
EndRem
Type TStopWatch
	
	Field _time      :Int = 0
	Field _is_running:Int = 0
	Field _millisecs :Int = 0
	
	Method Create:TStopWatch()
		Return Self
	EndMethod
	
	Rem
	bbdoc: Start stopping the time.
	EndRem
	Method start()
		Self._is_running = 1
		Self._millisecs = MilliSecs()
	EndMethod
	
	Rem
	bbdoc: Stop/Pause stopping the time.
	EndRem
	Method stop()
		If Self._is_running
			Self._time :+ MilliSecs() - Self._millisecs
			Self._millisecs = 0
			Self._is_running = 0
		EndIf
	EndMethod
	
	Rem
	bbdoc: Reset the time.
	EndRem
	Method reset()
		Self._time = 0
		Self._is_running = 0
		Self._millisecs = 0
	EndMethod
	
	Rem
	bbdoc: Check whether the watch is running.
	EndRem
	Method isRunning:Int()
		Return Self._is_running
	EndMethod
	
	Rem
	bbdoc: Returns the current stopped time.
	EndRem
	Method getTime:Int()
		If Self._is_running Then
			Return Self._time + MilliSecs() - Self._millisecs
		Else
			Return Self._time
		EndIf
	EndMethod
	
EndType